package edu.umich.popcup.util;

import java.io.IOException;
import java.io.InputStream;
import java.io.Serializable;

public class Image implements Serializable {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	public enum Pose {NONE, ABOVE, BELOW, FRONT, BACK, RIGHT, LEFT};
	public enum Category {NONE, STAPLER, MOUSE, CUP};
	
	static public class BoundingBox implements Serializable {
		/**
		 * 
		 */
		private static final long serialVersionUID = 1L;
		
		public float x1;
		public float y1;
		public float x2;
		public float y2;
		
		public BoundingBox(float x1, float y1, float x2, float y2) {
			this.x1 = x1;
			this.y1 = y1;
			this.x2 = x2;
			this.y2 = y2;
		}
		
		public BoundingBox() {
			x1 = 0;
			y1 = 0;
			x2 = 0;
			y2 = 0;
		}
		
		private void readObject(java.io.ObjectInputStream in)
	    throws IOException, ClassNotFoundException {
			in.defaultReadObject();
		}
		
		private void writeObject(java.io.ObjectOutputStream out)
	    throws IOException {
			out.defaultWriteObject();
		}
	}
	
	private Pose pose;
	private BoundingBox bBox;
	private Category cat;
	private byte [] imageData;
	
	public Image () {
		//pose = Pose.NONE;
		//cat = Category.NONE;
		bBox = new BoundingBox(0, 0, 0, 0);
		imageData = null;
		//imageData = 0;
	}
	
	public void setPose(Pose pose) {
		this.pose = pose;
	}
	
	public void setBoundingBox(BoundingBox boundingBox) {
		this.bBox = boundingBox;
	}
	
	public void setCategory(Category category) {
		this.cat = category;
	}
	
	public void setImageStream(InputStream in) {
		try {
			int size = in.available();
			imageData = new byte[size];
			int offset = 0;
			int remain = size;
			while (remain != 0) {
				int readByte = in.read(imageData, offset, remain);
				remain -= readByte;
				offset += readByte;
			}
		} catch (IOException e) {
			e.printStackTrace();
		}
		
	}
	
	public Pose getPose() {
		return pose;
		//return Pose.NONE;
	}
	
	public BoundingBox getBoundingBox() {
		return bBox;
	}
	
	public Category getCategory() {
		return cat;
		//return Category.NONE;
	}
	
	public byte [] getImageData() {
		return imageData;
	}
	
	/*public InputStream getImageStream() {
		return new BufferedInputStream(imageStream);
	}*/
	
	/*private void readObject(java.io.ObjectInputStream in)
    throws IOException, ClassNotFoundException {
		in.defaultReadObject();
		//imageData = (byte[])in.readObject();
	}
	
	private void writeObject(java.io.ObjectOutputStream out)
    throws IOException {
		out.defaultWriteObject();
		//out.write(imageData);
		//out.write(pose);
	}*/
}
